// 	UAEDocument.h
// 	Copyright  1991-92 by Apple Computer, Inc. All rights reserved.
//	Kent Sandvik DTS
//	This file contains the TAEDocument class, the basic TDocument
//	class used in the application.
//
//	<1>		khs		1.0		First final version


#ifndef __AEDOCUMENT__
#define __AEDOCUMENT__

//	INCLUDE FILES
#ifndef __AEGESTALT__
#include "UAEGestalt.h"
#endif

#ifndef __UINFORMATIONVIEW__
#include "UInformationView.h"
#endif

#ifndef __LABELVIEW__
#include "ULabelView.h"
#endif

#ifndef __LOOKUPCOMMAND__
#include "ULookupCommand.h"
#endif

#ifndef __AECLIENTCOMMAND__
#include "UAEClientCommand.h"
#endif

//	FORWARDING
class PascalObj TLabelView;
class PascalObj TInformationView;


//	CLASSES
class TAEDocument : public TDocument
{
public:
	TAEDocument();
	virtual pascal void IAEDocument();
	virtual pascal void Free();

	virtual pascal void DoMakeViews(Boolean		/*forPrinting*/);
	virtual pascal void DoEvent(EventNumber eventNum,
								TEventHandler* source,
								TEvent* event);


	virtual pascal void GetAEGestaltAddress(AEAddressDesc&);

	virtual pascal void DoSetupMenus();
	virtual pascal void DoMenuCommand(CommandNumber theNumber);

	virtual pascal void ReadConfiguration(Configuration*);
	virtual pascal void ProcessAEInformation();

	//	FIELDS
	TLabelView* fLabelView;
	TInformationView* fInfoView;
	TStaticText* fInfoField;
	TButton* fFindButton;
	TButton* fReportButton;
	AEAddressDesc fAEGestaltAddress;
	Configuration* fConfigurationInfo;
	Boolean fOKNode;
};

#endif __AEDOCUMENT__

