/* file: BigEasyVideoGrabber.c
 *
 * Started 12 December 1991, more or less.
 *
 * A set of routines for getting around
 * the unnecessarily baroque and spurious
 * video-digitizer and sequence-grabber
 * component interfaces.
 *
 * It implements the one straight-ahead
 * routine: GrabEasyVideoGrabber, which
 * grabs one video frame.
 *
 */


/*--------------------------
	Inclusions
--------------------------*/

#include <QuickTimeComponents.h>

/*--------------------------
	Types
--------------------------*/

typedef struct
	{
	ComponentInstance sg;	/* Sequence Grabber */
	ComponentInstance vc;	/* Video Channel */
	Rect preferredRect;		/* Size of digitizing area */
	} EasyVideoGrabberRecord, *EasyVideoGrabber;



/*--------------------------
	Routines
--------------------------*/

EasyVideoGrabber NewEasyVideoGrabber(Rect *outputSize);		/* returns the biggest it'll draw */
Boolean GrabEasyVideoGrabber(EasyVideoGrabber evg,Rect *r);	/* draws into current port */
void DisposeEasyVideoGrabber(EasyVideoGrabber evg);			/* close everything down */


